require "Sentencemate/version"

module Sentencemate
  #Object used to emulate a single word in text.
  class Word
    def initialize(word)
      @word = word
    end
    def append(str)
      @word = @word << str
      return @word
    end
    def get
      return @word
    end
    def setword(str)
      @word = str
    end
    def tag(str)
      @tag = str
    end
  end
# Object used to emulate a sentence in text.
  class Sentence
    def initialize(statement)
      @sentence = statement
      statement = statement.chop
      statement = statement.downcase
      lst = statement.split(" ")
      @words = []
      for elem in lst
        @words << Word.new(elem)
      end
      if @sentence[@sentence.length-1] == "?"
        @question = true
      else
        @question = false
      end
    end
    def addword(str)
      @words << Word.new(str)
    end
    def addword_to_place(str, i)
      @words.insert(i, Word.new(str))
    end
    def set_word(i, other)
      @words[i].setword(other)
    end
    def [](i)
      @words[i].get()
    end
    def length
      @words.length
    end
    def addpunc(symbol)
      @words[self.length-1].setword(@words[self.length-1].get << symbol)
    end
    def checkforword(str)
      for elem in @words
        if elem.get == str
          return true
        end
      end
      return false
    end
  end
#object meant to simulate a paragraph or block of text.
  class Paragraph
    def initialize(text)
      @paragraph = text
      @sentence_box = []
      count = 0
      until text.length == 0 do
        if text[count] == "."
          @sentence_box << Sentence.new(text[0..count])
          text = self.cutstring(text, 0, count)
          count = 0
        elsif text[count] == "?"
          @sentence_box << Sentence.new(text[0..count])
          text = self.cutstring(text, 0, count)
          count = 0
        elsif text[count] == "!"
          @sentence_box << Sentence.new(text[0..count])
          text = self.cutstring(text, 0, count)
          count = 0
        else
          count += 1
        end
      end
    end
    def cutstring(str, start, stop)
      str[start..stop] = ""
      return str
    end
    def [](i)
      @sentence_box[i]
    end
    def paragraph
      return @paragraph
    end
    def lettercount
      return @paragraph.split("").length
    end
    def wordcount
      return @paragraph.split(" ").length
    end
    def checkforword(str)
      for sentence in @sentence_box
        if sentence.checkforword(str)
          return true
        end
      end
      return false
    end
    def word_at_index(i)
      return @paragraph.split(" ")[i]
    end
  end
end
